/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnnotationLayer } from "./AnnotationLayer";
import { DependencyProperty } from "igniteui-angular-core/ES2015/DependencyProperty";
import { Base, Type, String_$type, typeCast, enumGetBox, fromEnum, runOn, delegateCombine, delegateRemove, Date_$type, Point_$type, markType } from "igniteui-angular-core/ES2015/type";
import { Series } from "./Series";
import { Brush } from "igniteui-angular-core/ES2015/Brush";
import { Thickness } from "igniteui-angular-core/ES2015/Thickness";
import { CalloutCollisionMode_$type } from "./CalloutCollisionMode";
import { FontUtil } from "igniteui-angular-core/ES2015/FontUtil";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { CalloutLayerFrame } from "./CalloutLayerFrame";
import { HashSet$1 } from "igniteui-angular-core/ES2015/HashSet$1";
import { CalloutAnnotationWrapper } from "./CalloutAnnotationWrapper";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { LinkedList$1 } from "igniteui-angular-core/ES2015/LinkedList$1";
import { Dictionary$2 } from "igniteui-angular-core/ES2015/Dictionary$2";
import { LinkedListNode$1 } from "igniteui-angular-core/ES2015/LinkedListNode$1";
import { LabelCollisionManager } from "igniteui-angular-core/ES2015/LabelCollisionManager";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { CalloutAnnotation } from "./CalloutAnnotation";
import { IFastItemsSource_$type } from "igniteui-angular-core/ES2015/IFastItemsSource";
import { CalloutSeriesSelectingEventArgs } from "./CalloutSeriesSelectingEventArgs";
import { CalloutStyleUpdatingEventArgs } from "./CalloutStyleUpdatingEventArgs";
import { QuadTreeBoundingBox } from "igniteui-angular-core/ES2015/QuadTreeBoundingBox";
import { LabelCollisionInfo } from "igniteui-angular-core/ES2015/LabelCollisionInfo";
import { ScalerParams } from "./ScalerParams";
import { Size } from "igniteui-angular-core/ES2015/Size";
import { CalloutContentUpdatingEventArgs } from "./CalloutContentUpdatingEventArgs";
import { CalloutLabelUpdatingEventArgs } from "./CalloutLabelUpdatingEventArgs";
import { CalloutKey } from "./CalloutKey";
import { DataContext } from "igniteui-angular-core/ES2015/DataContext";
import { HashPool$2 } from "igniteui-angular-core/ES2015/HashPool$2";
import { PropertyMetadata } from "igniteui-angular-core/ES2015/PropertyMetadata";
import { isNaN_ } from "igniteui-angular-core/ES2015/number";
import { stringIsNullOrEmpty } from "igniteui-angular-core/ES2015/string";
import { FastItemObjectColumn } from "igniteui-angular-core/ES2015/FastItemObjectColumn";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { BrushUtil } from "igniteui-angular-core/ES2015/BrushUtil";
import { TextBlock } from "igniteui-angular-core/ES2015/TextBlock";
import { DOMExecutionContext } from "igniteui-angular-core/ES2015/DOMExecutionContext";
import { Color } from "igniteui-angular-core/ES2015/Color";
import { Line } from "igniteui-angular-core/ES2015/Line";
import { CalloutViewHelper } from "./CalloutViewHelper";
import { Rectangle } from "igniteui-angular-core/ES2015/Rectangle";
import { TranslateTransform } from "igniteui-angular-core/ES2015/TranslateTransform";
/**
 * @hidden
 */
export class CalloutLayer extends AnnotationLayer {
    constructor() {
        super();
        this.calloutStyleUpdating = null;
        this.nf = null;
        this.ng = null;
        this.nh = null;
        this.ne = null;
        this.nd = null;
        this.n3 = new HashSet$1(CalloutAnnotationWrapper.$, 0);
        this.n6 = new List$1(CalloutAnnotationWrapper.$, 0);
        this.n7 = new List$1(CalloutAnnotationWrapper.$, 0);
        this.nb = null;
        this.n4 = new LinkedList$1(CalloutAnnotationWrapper.$);
        this.n1 = new Dictionary$2(CalloutAnnotationWrapper.$, LinkedListNode$1.$.specialize(CalloutAnnotationWrapper.$), 0);
        this.nn = null;
        this.qw = new Rect(0, 0, 0, 1, 1);
        this.nt = false;
        this.oh = 0;
        this.qv = Rect.empty;
        this.ns = false;
        this.calloutContentUpdating = null;
        this.calloutLabelUpdating = null;
        this.calloutSeriesSelecting = null;
        this.n5 = new List$1(SeriesPointOfInterest.$, 0);
        this.nv = false;
        this.nw = false;
        this.n9 = 0;
        this.nu = false;
        this.nr = true;
        FastItemObjectColumn.m();
        this.ma = true;
        let a = new CalloutLayerFrame();
        let b = new CalloutLayerFrame();
        let c = new CalloutLayerFrame();
        let d = this.fi / 1000;
        this.l2 = a;
        this.l1 = b;
        this.l3 = c;
        this.ab = CalloutLayer.$;
    }
    po(a, b) {
        this.n7.clear();
        this.jd(false);
    }
    hy(a, b, c, d) {
        super.hy(a, b, c, d);
        let e = this.n2();
        switch (a) {
            case 3:
                this.p0(b, e);
                break;
            case 1:
                for (let f = b; f < b + c; f++) {
                    let g = new CalloutAnnotation();
                    let h = new CalloutAnnotationWrapper();
                    h.b = g;
                    h.b.series = this.na;
                    this.n7.insert(f, h);
                    this.p0(f, e);
                }
                break;
            case 0:
                this.n7.v(b, c);
                break;
            case 2:
                for (let i = b; i < b + c; i++) {
                    this.p0(i, e);
                }
                break;
            case 4:
                this.n7.clear();
                for (let j = 0; j < this.bz.count; j++) {
                    let k = new CalloutAnnotation();
                    let l = new CalloutAnnotationWrapper();
                    l.b = k;
                    l.b.series = this.na;
                    this.n7.add(l);
                    this.p0(j, e);
                }
                break;
        }
        this.jd(true);
    }
    da(a) {
        return false;
    }
    n2() {
        let a = new Dictionary$2(String_$type, Series.$, 0);
        if (this.bs != null) {
            for (let b = 0; b < this.bs.series.count; b++) {
                let c = this.bs.series._inner[b];
                if (c.name != null && !a.containsKey(c.name)) {
                    a.addItem(c.name, c);
                }
            }
        }
        return a;
    }
    p0(a, b) {
        if (this.nm == null || this.nk == null) {
            return;
        }
        let c = a;
        if (this.nl != null) {
            c = this.nl.item(a);
        }
        let d = this.nm.item(a);
        let e = this.nk.item(a);
        let f = this.n7._inner[a];
        f.b.xValue = c;
        f.b.yValue = d;
        f.b.text = e != null ? e.toString() : "";
        if (this.nj != null) {
            f.b.key = this.nj.item(a);
        }
        if (this.ni != null) {
            f.b.content = this.ni.item(a);
        }
        else {
            f.b.content = this.bz.item(a);
        }
        if (this.calloutSeriesSelecting != null) {
            let g = ((() => {
                let $ret = new CalloutSeriesSelectingEventArgs();
                $ret.c = c;
                $ret.d = d;
                $ret.item = this.bz.item(a);
                return $ret;
            })());
            this.calloutSeriesSelecting(this, g);
            if (g.a != null) {
                f.b.series = g.a;
            }
            else if (g.e != null) {
                if (b.containsKey(g.e)) {
                    f.b.series = b.item(g.e);
                }
            }
        }
        this.p1(f);
    }
    p1(a) {
        let b = new Thickness(0, 3);
        if (isNaN_(this.qy.c) || isNaN_(this.qy.e) || isNaN_(this.qy.d) || isNaN_(this.qy.b)) {
            b = new Thickness(0, 3);
        }
        else {
            b = this.qy;
        }
        let c = this.qr != null ? this.qr : this.m7.ce(a.b.series);
        let d = this.qu != null ? this.qu : this.m7.ch();
        let e = this.qt != null ? this.qt : this.m7.cg();
        let f = this.qs != null ? this.qs : this.m7.cf(a.b.series);
        let g = isNaN_(this.of) ? 0 : this.of;
        if (this.nz && this.calloutStyleUpdating != null) {
            let h = new CalloutStyleUpdatingEventArgs();
            h.item = a.b.content;
            h.xValue = a.b.xValue;
            h.yValue = a.b.yValue;
            h.series = a.b.series;
            h.background = c;
            h.textColor = d;
            h.outline = e;
            h.leaderBrush = f;
            h.strokeThickness = g;
            this.calloutStyleUpdating(this, h);
            c = h.background;
            d = h.textColor;
            e = h.outline;
            f = h.leaderBrush;
            g = h.strokeThickness;
        }
        a.b.backgroundPadding = b;
        a.b.background = c;
        a.b.textColor = d;
        a.b.outline = e;
        a.b.leaderBrush = f;
        a.b.strokeThickness = g;
    }
    fs(a, b) {
        let c = this.gu(b);
        if (c == CalloutLayer.$$p[19]) {
            return this.ft(a, b, this.pc);
        }
        if (c == CalloutLayer.$$p[23]) {
            return this.ft(a, b, this.pj);
        }
        if (c == CalloutLayer.$$p[24]) {
            return this.ft(a, b, this.pm);
        }
        if (c == CalloutLayer.$$p[18]) {
            return this.ft(a, b, this.o9);
        }
        if (c == CalloutLayer.$$p[14]) {
            return this.ft(a, b, this.o3);
        }
        return super.fs(a, b);
    }
    get nk() {
        return this.nf;
    }
    set nk(a) {
        if (this.nf != a) {
            let b = this.nf;
            this.nf = a;
            this.raisePropertyChanged("LabelColumn", b, this.nf);
        }
    }
    get nl() {
        return this.ng;
    }
    set nl(a) {
        if (this.ng != a) {
            let b = this.ng;
            this.ng = a;
            this.raisePropertyChanged("XColumn", b, this.ng);
        }
    }
    get nm() {
        return this.nh;
    }
    set nm(a) {
        if (this.nh != a) {
            let b = this.nh;
            this.nh = a;
            this.raisePropertyChanged("YColumn", b, this.nh);
        }
    }
    get nj() {
        return this.ne;
    }
    set nj(a) {
        if (this.ne != a) {
            let b = this.ne;
            this.ne = a;
            this.raisePropertyChanged("KeyColumn", b, this.ne);
        }
    }
    get ni() {
        return this.nd;
    }
    set ni(a) {
        if (this.nd != a) {
            let b = this.nd;
            this.nd = a;
            this.raisePropertyChanged("ContentColumn", b, this.nd);
        }
    }
    pq(a, b) {
        if (b.propertyName == CalloutAnnotation.$$p[13] || b.propertyName == CalloutAnnotation.$$p[14]) {
            let c = a.k;
            if (!this.n3.contains(c)) {
                this.n6.add(c);
                this.jd(false);
            }
        }
    }
    bf() {
        return new CalloutLayerView(this);
    }
    iu(a) {
        super.iu(a);
        this.m7 = a;
    }
    get qy() {
        return new Thickness(1, this.ob, this.od, this.oc, this.oa);
    }
    get nc() {
        if (this.nb == null) {
            this.nb = FontUtil.toFontInfo(this.e4, this.pf);
        }
        return this.nb;
    }
    ml(a, b) {
        if (this.na == null || this.na == a) {
            if (!this.aq.c) {
                this.jd(b);
            }
        }
    }
    mn(a, b) {
        super.mn(a, b);
        let c = a;
        c.p.clear();
        c.q.clear();
        c.m.clear();
        c.f.clear();
        c.h.clear();
        c.g.clear();
        c.j.clear();
        c.l.clear();
        c.k.clear();
        c.i.clear();
        c.n.clear();
        c.o.clear();
        c.t.clear();
        c.u.clear();
        c.r.clear();
        c.s.clear();
        let d = this.n8();
        let e = new List$1(CalloutAnnotationWrapper.$, 0);
        if (this.nx) {
            if (this.l8(this.na)) {
                this.px(this.na, c, e);
            }
            else {
                for (let f of fromEnum(this.bs.series)) {
                    if (this.l8(f)) {
                        this.px(f, c, e);
                    }
                }
            }
        }
        this.pw(c, d, e);
    }
    jt(a, b) {
        super.jt(a, b);
        let c = b.width - this.qw.width;
        let d = b.height - this.qw.height;
        let e = 0;
        if (Math.abs(c) > Math.abs(d)) {
            e = c;
            this.n9 = c * this.ly.width;
        }
        else {
            e = d;
            this.n9 = d * this.ly.height;
        }
        if (e > 0 && this.n9 > 5) {
            this.nw = true;
        }
        if (e < 0 && this.n9 > 5) {
            this.nv = true;
        }
    }
    js(a, b) {
        super.js(a, b);
        if (!a.equals1(b)) {
            this.nu = true;
        }
    }
    get qx() {
        return this.qv;
    }
    set qx(a) {
        this.qv = a;
    }
    pw(a, b, c) {
        if (this.bs != null) {
            this.qw = this.bs.mq;
        }
        if (this.ly.isEmpty) {
            return;
        }
        this.qx = new Rect(0, this.ly.left, this.ly.top, this.ly.width, this.ly.height);
        if (this.nn != null && this.o0 != null && this.o0 != this.nn.ak) {
            this.ps();
        }
        if (this.nn == null) {
            let d = this.no();
            if (d != null) {
                this.nn = d;
                let e = this.nn;
                e.labelsMoved = delegateCombine(e.labelsMoved, runOn(this, this.pp));
            }
            else {
                let f = this.lq(this.bi);
                let g = 0;
                if (this.na != null) {
                    if (this.na.isVertical) {
                        g = 2;
                    }
                }
                else {
                    let h = false;
                    if (this.bs != null && this.bs.series.count > 0) {
                        h = true;
                        for (let i of fromEnum(this.bs.series)) {
                            if (!i.cj) {
                                if (!i.isVertical) {
                                    h = false;
                                }
                            }
                        }
                    }
                    if (h) {
                        g = 2;
                    }
                }
                this.nn = new LabelCollisionManager(this.ly.right, this.ly.bottom, this.ly, this.m7.b4(), this.oe, this.np(), g, this.ol(), this.ok(), this.ny);
                if (this.o0 != null) {
                    this.nn.ak = this.o0;
                    this.nn.ai = this;
                }
                let j = this.nn;
                j.labelsMoved = delegateCombine(j.labelsMoved, runOn(this, this.pp));
            }
        }
        if (this.nv) {
            this.nv = false;
            if (this.nn.ag > 2) {
                this.nt = true;
            }
        }
        if (this.nw) {
            this.nw = false;
            if (this.n9 > 5) {
                this.nt = true;
            }
        }
        if (this.nu) {
            this.nu = false;
            this.nn.ax(this.ly.right, this.ly.bottom, this.ly);
            this.nt = true;
        }
        let k = new HashSet$1(CalloutAnnotationWrapper.$, 0);
        let l = new HashSet$1(CalloutAnnotationWrapper.$, 0);
        let m = new List$1(CalloutAnnotationWrapper.$, 0);
        let n = new List$1(CalloutAnnotationWrapper.$, 0);
        let o = new HashSet$1(CalloutAnnotationWrapper.$, 0);
        for (let p = 0; p < b.count; p++) {
            o.add_1(b._inner[p]);
        }
        for (let q = 0; q < c.count; q++) {
            o.add_1(c._inner[q]);
        }
        let r = this.n4.c;
        while (r != null) {
            let s = r.a;
            if (!o.contains(r.c)) {
                n.add(r.c);
                l.add_1(r.c);
                let t = r.c.b;
                t.propertyChanged = delegateRemove(t.propertyChanged, runOn(this, this.pq));
                this.n4.h(r);
                this.n1.removeItem(r.c);
                this.nn.aw(r.c.c);
            }
            r = s;
        }
        for (let u = 0; u < b.count; u++) {
            if (!this.n1.containsKey(b._inner[u])) {
                this.n4.f(b._inner[u]);
                let v = b._inner[u].b;
                v.propertyChanged = delegateCombine(v.propertyChanged, runOn(this, this.pq));
                this.n1.addItem(b._inner[u], this.n4.d);
                m.add(b._inner[u]);
                k.add_1(b._inner[u]);
                this.nt = true;
            }
        }
        for (let w = 0; w < c.count; w++) {
            if (!this.n1.containsKey(c._inner[w])) {
                this.n4.f(c._inner[w]);
                this.n1.addItem(c._inner[w], this.n4.d);
                let x = c._inner[w].b;
                x.propertyChanged = delegateCombine(x.propertyChanged, runOn(this, this.pq));
                m.add(c._inner[w]);
                k.add_1(c._inner[w]);
                this.nt = true;
            }
        }
        if (this.n6.count > 0) {
            this.nt = true;
            this.n6.clear();
            this.n3.clear();
        }
        r = this.n4.c;
        while (r != null) {
            let y = this.nq(r.c);
            if (y == null) {
                return;
            }
            if (!Base.equalsStatic(y, r.c.c.c)) {
                let z = false;
                if (r.c.c.c == null) {
                    z = true;
                }
                let aa = r.c.c;
                aa.o = y.b;
                aa.p = y.c;
                if (!isNaN_(aa.o) && !isNaN_(aa.p)) {
                    aa.n = y.e;
                    aa.m = y.d;
                    if (aa.b == null) {
                        this.nn.p(aa);
                    }
                    if (z) {
                        this.nn.al(aa);
                    }
                    else {
                        this.nn.at(aa);
                    }
                }
            }
            r = r.a;
        }
        let ab = this.nn.ah();
        let ac = this.nn.q();
        if (this.nt && (ab != 0 || ac)) {
            this.nt = false;
            this.oh = 0x7FFFFFFF;
            if (this.o0 != null) {
                let ad = true;
                for (let ae = 0; ae < this.bs.series.count; ae++) {
                    let af = this.bs.series._inner[ae];
                    if (af.cj && typeCast(CalloutLayer.$, af) !== null) {
                        let ag = af;
                        if (ag.o0 == this.o0) {
                            if (!ag.qx.equals1(this.nn.az)) {
                                ad = false;
                                break;
                            }
                        }
                    }
                }
                if (ad) {
                    this.nn.ay();
                }
                else {
                    this.nn.am();
                }
            }
            else {
                this.nn.ay();
            }
        }
        let ah = this.n4.c;
        while (ah != null) {
            let ai = ah.c;
            a.m.add1(ai);
            a.f.add(ai.b.background);
            a.h.add(ai.b.outline);
            a.g.add(ai.b.leaderBrush);
            a.j.add(ai.b.backgroundPadding.c);
            a.l.add(ai.b.backgroundPadding.e);
            a.k.add(ai.b.backgroundPadding.d);
            a.i.add(ai.b.backgroundPadding.b);
            a.n.add(ai.b.strokeThickness);
            a.o.add(ai.b.textColor);
            a.p.add1(ai.b.text);
            a.q.add1(ai.b.content);
            let aj = ai.c;
            a.t.add(ai.c.o - (ai.c.g - ai.c.l));
            a.u.add(ai.c.p - (ai.c.h - ai.c.k));
            a.r.add(ai.c.g - ai.c.l);
            a.s.add(ai.c.h - ai.c.k);
            ah = ah.a;
        }
    }
    ps() {
        if (this.nn != null) {
            let a = this.n4.c;
            while (a != null) {
                let b = a.c.c;
                if (b != null) {
                    this.nn.aw(b);
                }
                a = a.a;
            }
            let c = this.nn;
            c.labelsMoved = delegateRemove(c.labelsMoved, runOn(this, this.pp));
            this.nn = null;
        }
        this.pr();
    }
    no() {
        if (this.bs == null) {
            return null;
        }
        for (let a = 0; a < this.bs.series.count; a++) {
            let b = this.bs.series._inner[a];
            if (b.cj && typeCast(CalloutLayer.$, b) !== null) {
                let c = b;
                if (c != this) {
                    if (c.o0 != null && c.o0 == this.o0) {
                        if (c.nn != null) {
                            return c.nn;
                        }
                    }
                }
            }
        }
        return null;
    }
    ok() {
        return 20000;
    }
    ol() {
        return 300;
    }
    np() {
        switch (this.m4) {
            case 0: return 2;
            case 2: return 1;
            case 3: return 2;
            case 1: return 0;
        }
        return 2;
    }
    pp(a) {
        let b = this.nn.ah();
        if (b < this.oh) {
            this.oh = b;
            this.jd(false);
        }
    }
    nq(a) {
        let b = this.na;
        if (a.b.series != null) {
            b = a.b.series;
        }
        if (b == null) {
            for (let c = 0; c < this.bs.series.count; c++) {
                let d = this.bs.series._inner[c];
                if (!d.cj) {
                    b = d;
                    break;
                }
            }
        }
        if (b == null) {
            return null;
        }
        let e = b.ag();
        let f = b.eh();
        let g = null;
        let h = null;
        for (let i = 0; i < e.length; i++) {
            if (e[i].cf) {
                h = e[i];
            }
            else {
                g = e[i];
            }
        }
        if (g == null || h == null) {
            return null;
        }
        if (!g.ce() || !h.ce()) {
            return null;
        }
        let j = 0;
        let k = 0;
        if (g.b2 && g.categoryMode != 0) {
            if (b.cr) {
                j = b.getOffsetValue();
            }
            else if (b.cl) {
                j = b.getOffsetValue();
            }
        }
        if (h.b2 && h.categoryMode != 0) {
            if (b.cl) {
                k = b.getOffsetValue();
            }
        }
        let l = new ScalerParams(0, this.bs.mq, g.i1, g.b8, g.iw());
        l.b = f;
        let m = new ScalerParams(0, this.bs.mq, h.i1, h.b8, h.iw());
        m.b = f;
        let n = g.dw(this.og(a.b.xValue), l) + j;
        let o = h.dw(this.og(a.b.yValue), m) + k;
        let p = new QuadTreeBoundingBox();
        p.b = n;
        p.c = o;
        p.e = 3;
        p.d = 3;
        p.g = a.b;
        return p;
    }
    og(a) {
        if (typeCast(Date_$type, a) !== null) {
            return a.getTime();
        }
        if (a == null) {
            return 0;
        }
        return a;
    }
    n8() {
        let a = new List$1(CalloutAnnotationWrapper.$, 0);
        for (let b = 0; b < this.n7.count; b++) {
            if (stringIsNullOrEmpty(this.n7._inner[b].b.text)) {
                continue;
            }
            if (this.n7._inner[b].c == null) {
                let c = new LabelCollisionInfo();
                this.n7._inner[b].c = c;
                let d = this.m7.cj(this.om(this.n7._inner[b]), this.n7._inner[b].b.backgroundPadding);
                c.k = d.height / 2;
                c.l = d.width / 2;
            }
            let e = this.nq(this.n7._inner[b]);
            if (e == null || e.b < this.ly.left || e.b > this.ly.right || e.c < this.ly.top || e.c > this.ly.bottom) {
                continue;
            }
            a.add(this.n7._inner[b]);
        }
        return a;
    }
    om(a) {
        return a.b.text;
    }
    l8(a) {
        if (!super.l8(a)) {
            return false;
        }
        return true;
    }
    io() {
        super.io();
        if (!this.aq.c && !this.ca()) {
            return;
        }
        if (this.nr) {
            this.nr = false;
            this.pu();
        }
        if (this.ca()) {
            this.pz(this.l3, false);
        }
        else {
            this.pz(this.l1, false);
        }
    }
    pv() {
        if (!this.ns) {
            this.ns = true;
            this.jd(true);
        }
    }
    px(a, b, c) {
        if (a.ch(this.n5, this.n0, this.oi)) {
            let d = this.n5;
            for (let e = 0; e < this.n5.count; e++) {
                let f = d._inner[e];
                let g = f.a.item != null ? f.a.item : f.a;
                let h = a;
                let i = new CalloutKey(g, h);
                let j = new CalloutAnnotationWrapper();
                let k = new CalloutAnnotation();
                j.b = k;
                k.key = i;
                let l = false;
                let m = false;
                if (this.ns) {
                    this.ns = false;
                    m = true;
                }
                if (this.n1.containsKey(j)) {
                    j = this.n1.item(j).c;
                    k = j.b;
                }
                else {
                    if (!m) {
                        l = true;
                    }
                }
                let n = k.xValue;
                let o = k.yValue;
                if (this.og(n) != this.og(f.b)) {
                    k.xValue = f.b;
                }
                if (this.og(o) != this.og(f.c)) {
                    k.yValue = f.c;
                }
                k.series = a;
                if (l && this.calloutLabelUpdating != null) {
                    let p = ((() => {
                        let $ret = new CalloutLabelUpdatingEventArgs();
                        $ret.c = k.xValue;
                        $ret.d = k.yValue;
                        $ret.item = g;
                        return $ret;
                    })());
                    this.calloutLabelUpdating(this, p);
                    if (p.b != null && !Base.equalsStatic(p.b, j.b.text)) {
                        let q = p.b;
                        j.b.text = q != null ? q.toString() : "";
                    }
                }
                else {
                    if (f.d != null) {
                        k.text = f.d;
                    }
                }
                if (k.text == null) {
                    continue;
                }
                if (l) {
                    if (this.calloutContentUpdating != null) {
                        let r = ((() => {
                            let $ret = new CalloutContentUpdatingEventArgs();
                            $ret.c = k.xValue;
                            $ret.d = k.yValue;
                            $ret.item = g;
                            $ret.a = g;
                            return $ret;
                        })());
                        this.calloutContentUpdating(this, r);
                        if (r.a != null && r.a != j.b.content) {
                            j.b.content = r.a;
                        }
                    }
                    else {
                        if (g != null && g != j.b.content) {
                            j.b.content = g;
                        }
                    }
                }
                if (l) {
                    this.p1(j);
                }
                if (j.c == null) {
                    let s = new LabelCollisionInfo();
                    j.c = s;
                    let t = this.m7.cj(this.om(j), j.b.backgroundPadding);
                    s.k = t.height / 2;
                    s.l = t.width / 2;
                }
                let u = this.nq(j);
                if (u == null || u.b < this.ly.left || u.b > this.ly.right || u.c < this.ly.top || u.c > this.ly.bottom) {
                    continue;
                }
                c.add(j);
            }
        }
    }
    bd() {
        return 1;
    }
    ar(a, b) {
        let c = this.nn.d(a, b);
        if (c == null) {
            return null;
        }
        return c.u;
    }
    dh(a, b) {
        if (this.nn == null) {
            return false;
        }
        return this.nn.d(a, b) != null;
    }
    pz(a, b) {
        let c = 0;
        let d = new HashSet$1(CalloutAnnotationWrapper.$, 0);
        for (c = 0; c < a.p.count; c++) {
            let e = a.m._inner[c];
            if (isNaN_(a.t._inner[c]) || isNaN_(a.u._inner[c])) {
                continue;
            }
            let f = this.m7.b6.item(e);
            d.add_1(e);
            if (f.f != a.p._inner[c]) {
                f.f = a.p._inner[c];
                let g = f.s();
            }
            f.c = a.n._inner[c];
            f.k = a.f._inner[c];
            f.n = a.o._inner[c];
            f.m = f.c > 0 ? a.h._inner[c] : this.bi.bn();
            f.l = a.g._inner[c];
            f.v = new Thickness(1, a.j._inner[c], a.l._inner[c], a.k._inner[c], a.i._inner[c]);
            this.m7.cc(f, Math.min(a.r._inner[c], a.r._inner[c] + a.t._inner[c]), Math.min(a.s._inner[c], a.s._inner[c] + a.u._inner[c]));
            this.m7.cd(f, e, a.q._inner[c]);
            f.p = { $type: Point_$type, x: a.t._inner[c], y: a.u._inner[c] };
        }
        let h = new List$1(CalloutAnnotationWrapper.$, 0);
        for (let i of fromEnum(this.m7.b6.c)) {
            if (!d.contains(i)) {
                h.add(i);
            }
        }
        for (let j = 0; j < h.count; j++) {
            this.m7.b6.g(h._inner[j]);
        }
    }
    mq(a, b) {
        super.mq(a, b);
        if (this.ca()) {
            this.pz(this.l3, true);
        }
        else {
            this.pz(this.l1, false);
        }
    }
    c8() {
        return true;
    }
    iz(a, b, c, d) {
        super.iz(a, b, c, d);
        switch (b) {
            case CalloutLayer.$$p[21]:
                this.nb = null;
                this.jd(true);
                break;
            case CalloutLayer.$$p[20]:
                this.jd(true);
                break;
            case CalloutLayer.$$p[13]:
                this.jd(true);
                break;
            case "SeriesViewer":
                if (c != null) {
                    let e = c;
                    e.seriesAnimating = delegateRemove(e.seriesAnimating, runOn(this, this.py));
                }
                if (d != null) {
                    let f = d;
                    f.seriesAnimating = delegateCombine(f.seriesAnimating, runOn(this, this.py));
                }
                if (d == null) {
                    this.ps();
                }
                break;
            case CalloutLayer.$$p[15]:
            case CalloutLayer.$$p[16]:
            case CalloutLayer.$$p[1]:
            case CalloutLayer.$$p[5]:
            case CalloutLayer.$$p[4]:
            case CalloutLayer.$$p[7]:
            case CalloutLayer.$$p[9]:
            case CalloutLayer.$$p[8]:
            case CalloutLayer.$$p[6]:
            case CalloutLayer.$$p[11]:
            case CalloutLayer.$$p[12]:
                this.pt();
                break;
            case CalloutLayer.$$p[19]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nk);
                    this.nk = this.by(this.pc);
                }
                break;
            case "LabelColumn":
                this.pt();
                break;
            case CalloutLayer.$$p[14]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.ni);
                    this.ni = this.by(this.o3);
                }
                break;
            case "ContentColumn":
                this.pt();
                break;
            case CalloutLayer.$$p[23]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nl);
                    this.nl = stringIsNullOrEmpty(this.pj) == false ? this.by(this.pj) : null;
                }
                break;
            case "XColumn":
                this.pt();
                break;
            case CalloutLayer.$$p[24]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nm);
                    this.nm = this.by(this.pm);
                }
                break;
            case "YColumn":
                this.pt();
                break;
            case CalloutLayer.$$p[18]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nj);
                    this.nj = this.by(this.o9);
                }
                break;
            case "KeyColumn":
                this.pt();
                break;
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.nk);
                    c.deregisterColumn(this.ni);
                    c.deregisterColumn(this.nl);
                    c.deregisterColumn(this.nm);
                    c.deregisterColumn(this.nj);
                    this.nk = null;
                    this.ni = null;
                    this.nl = null;
                    this.nm = null;
                    this.nj = null;
                    this.n7.clear();
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.nk = this.by(this.pc);
                    this.ni = this.by(this.o3);
                    if (stringIsNullOrEmpty(this.pj) == false) {
                        this.nl = this.by(this.pj);
                    }
                    this.nm = this.by(this.pm);
                    this.nj = this.by(this.o9);
                }
                this.pt();
                break;
        }
    }
    py(a) {
        if (a.cj) {
            return;
        }
        if ((a == this.na || this.na == null) && this.nx) {
            this.jd(false);
        }
    }
    pt() {
        if (this.nr == false) {
            this.nr = true;
            this.jd(false);
        }
    }
    pr() {
        this.m7.b6.clear();
        this.n4.g();
        this.n1.clear();
    }
    pu() {
        if (this.nm == null || this.nk == null) {
            let a = this.n4.c;
            while (a != null) {
                this.p1(a.c);
                a = a.a;
            }
            return;
        }
        let b = this.n2();
        for (let c = 0; c < this.nm.count; c++) {
            let d;
            if (this.n7.count <= c) {
                let e = new CalloutAnnotation();
                d = new CalloutAnnotationWrapper();
                d.b = e;
                d.b.series = this.na;
                this.n7.add(d);
            }
            else {
                d = this.n7._inner[c];
            }
            this.p0(c, b);
        }
    }
}
CalloutLayer.$t = markType(CalloutLayer, 'CalloutLayer', AnnotationLayer.$);
Type.dep(DependencyProperty, PropertyMetadata, CalloutLayer, 'raisePropertyChanged', ['AutoCalloutLabelPrecision:oi:p2', [1, 5], 'CalloutBackground:qr:p3', [Brush.$, null], 'CalloutCollisionMode:m4:p4', [CalloutCollisionMode_$type, enumGetBox(CalloutCollisionMode_$type, 3)], 'CalloutInterpolatedValuePrecision:oj:p5', [1, -1], 'CalloutLeaderBrush:qs:p6', [Brush.$, null], 'CalloutOutline:qt:p7', [Brush.$, null], 'CalloutPaddingBottom:oa:p8', [1, NaN], 'CalloutPaddingLeft:ob:p9', [1, NaN], 'CalloutPaddingRight:oc:qa', [1, NaN], 'CalloutPaddingTop:od:qb', [1, NaN], 'CalloutPositionPadding:oe:qc', [1, 10], 'CalloutStrokeThickness:of:qd', [1, NaN], 'CalloutTextColor:qu:qe', [Brush.$, null], 'CollisionChannel:o0:qf', [2, null], 'ContentMemberPath:o3:qg', [2, null], 'IsAutoCalloutBehaviorEnabled:nx:qh', [0, false], 'IsCalloutOffsettingEnabled:ny:qi', [0, true], 'IsCustomCalloutStyleEnabled:nz:qj', [0, false], 'KeyMemberPath:o9:qk', [2, null], 'LabelMemberPath:pc:ql', [2, null], 'TargetSeries:na:qm', [Series.$, null], 'TextStyle:pf:qn', [2, null], 'UseValueForAutoCalloutLabels:n0:qo', [0, true], 'XMemberPath:pj:qp', [2, null], 'YMemberPath:pm:qq', [2, null]]);
/**
 * @hidden
 */
export class CalloutLayerView extends AnnotationLayerView {
    constructor(a) {
        super(a);
        this.b1 = null;
        this.b7 = null;
        this.b6 = null;
        this.b8 = NaN;
        this.b2 = null;
        this.b1 = a;
        this.b7 = new List$1(CalloutView.$, 0);
    }
    ap() {
        super.ap();
        this.b6 = ((() => {
            let $ret = new HashPool$2(CalloutAnnotationWrapper.$, CalloutView.$);
            $ret.create = runOn(this, this.b3);
            $ret.activate = runOn(this, this.b9);
            $ret.disactivate = runOn(this, this.cb);
            $ret.destroy = runOn(this, this.ca);
            return $ret;
        })());
    }
    b3() {
        let a = new CalloutView(this);
        this.b7.add(a);
        return a;
    }
    b9(a) {
        a.w = 0;
    }
    cb(a) {
        a.w = 1;
    }
    ca(a) {
        this.b7.remove(a);
    }
    ci(a) {
        if (a == null) {
            return a;
        }
        return BrushUtil.h(a, 0.1);
    }
    a3(a, b) {
        super.a3(a, b);
        a.ac(this.b5());
        if (a.d && !b) {
            for (let c = 0; c < this.b7.count; c++) {
                let d = this.b7._inner[c];
                if (d.w == 0) {
                    d.h(a);
                }
            }
        }
    }
    b5() {
        if (this.b1.nc != null) {
            return this.b1.nc;
        }
        return this.e.bs.getFontInfo();
    }
    ai(a) {
        super.ai(a);
        for (let b = 0; b < this.b7.count; b++) {
            let c = this.b7._inner[b];
            if (c.w != 0) {
                continue;
            }
            c.g(this.b1, this.b5(), a);
        }
    }
    ck(a) {
        if (isNaN_(this.b8)) {
            this.b8 = this.e.bs.bn.a7;
        }
        return new Size(1, this.h.f(a.ak), this.b8);
    }
    cj(a, b) {
        if (this.b2 == null) {
            this.b2 = new CalloutView(this);
        }
        this.b2.f = a;
        this.b2.v = b;
        let c = this.b2.s();
        this.b2.f = null;
        return c;
    }
    b4() {
        return new DOMExecutionContext(this.e.bs.bn.i.ae);
    }
    cc(a, b, c) {
        a.d = b;
        a.e = c;
    }
    cd(a, b, c) {
        a.i(this.e, b, c);
    }
    ce(a) {
        if (a != null) {
            return this.ci(a.k3);
        }
        return this.e.k3;
    }
    ch() {
        return ((() => {
            let $ret = new Brush();
            $ret.color = Color.u(255, 255, 255, 255);
            return $ret;
        })());
    }
    cg() {
        return ((() => {
            let $ret = new Brush();
            $ret.color = Color.u(255, 255, 255, 255);
            return $ret;
        })());
    }
    cf(a) {
        if (a != null) {
            return this.ci(a.k3);
        }
        return this.e.k3;
    }
}
CalloutLayerView.$t = markType(CalloutLayerView, 'CalloutLayerView', AnnotationLayerView.$);
/**
 * @hidden
 */
export class CalloutView extends Base {
    constructor(a) {
        super();
        this.a = null;
        this.w = 0;
        this.j = null;
        this.r = null;
        this.o = { $type: Point_$type, x: 0, y: 0 };
        this.q = null;
        this.u = new Thickness(0, 0);
        this.t = null;
        this.d = 0;
        this.e = 0;
        this.b = null;
        this.q = new Line();
        this.q.ab = false;
        this.q._stroke = ((() => {
            let $ret = new Brush();
            $ret.color = Color.u(255, 0, 0, 0);
            return $ret;
        })());
        this.q.ac = 2;
        this.j = new TextBlock();
        this.r = new Rectangle();
        this.r.ac = 0;
        this.a = a;
        this.w = 0;
    }
    h(a) {
        a.z();
        a.af(this.d, this.e);
        let b = new TranslateTransform();
        b.j = this.t.c;
        b.k = this.t.e;
        this.r.j = b;
        a.r(this.q);
        a.z();
        this.r.width = this.j.m + this.u.c + this.u.d;
        this.r.height = this.j.l + this.u.e + this.u.b;
        a.j(this.r.j);
        a.v(this.r);
        this.j.o = this.u.e;
        this.j.n = this.u.c;
        a.w(this.j);
        a.y();
        a.y();
    }
    get p() {
        return this.o;
    }
    set p(a) {
        if (this.o.x != a.x || this.o.y != a.y) {
            let b = this.s();
            let c = b.height;
            let d = b.width;
            this.o = a;
            let e = CalloutViewHelper.b(this.p, d, c, this.q);
            this.t = e;
        }
    }
    get n() {
        return this.j.am;
    }
    set n(a) {
        this.j.am = a;
    }
    get m() {
        return this.r._stroke;
    }
    set m(a) {
        this.r._stroke = a;
    }
    get l() {
        return this.q._stroke;
    }
    set l(a) {
        this.q._stroke = a;
    }
    get k() {
        return this.r._fill;
    }
    set k(a) {
        this.r._fill = a;
    }
    get c() {
        return this.r.ac;
    }
    set c(a) {
        this.r.ac = a;
    }
    get v() {
        return this.u;
    }
    set v(a) {
        this.u = a;
    }
    get f() {
        return this.j.ak;
    }
    set f(a) {
        if (a == null) {
            this.j.ak = "";
        }
        else {
            this.j.ak = a.toString();
        }
        let b = this.s();
        let c = b.height;
        let d = b.width;
        let e = CalloutViewHelper.b(this.p, d, c, this.q);
        this.t = e;
    }
    s() {
        let a = this.a.ck(this.j);
        this.j.m = a.width;
        this.j.l = a.height;
        return new Size(1, a.width + this.u.c + this.u.d, a.height + this.u.e + this.u.b);
    }
    i(a, b, c) {
        if (this.b == null) {
            this.b = new DataContext();
        }
        this.b.series = a;
        this.b.item = c;
        if (b.c != null) {
            b.c.u = this.b;
        }
    }
    g(a, b, c) {
        a.a2.exportCalloutData(this.d, this.e, this.t.c, this.t.e, c, this.r, this.j, b, this.q, "callout", ["Main", "Callout"]);
    }
}
CalloutView.$t = markType(CalloutView, 'CalloutView');
//# sourceMappingURL=CalloutLayer_combined.js.map