import { Type } from "igniteui-angular-core/ES2015/type";
/**
 * Describes available types of data visualizations in the Category Chart
 */
export declare enum CategoryChartType {
    /**
     * Specifies category line series with markers at each data point
     */
    Line = 0,
    /**
     * Specifies category area series
     */
    Area = 1,
    /**
     * Specifies category column chart with vertical rectangles at each data point
     */
    Column = 2,
    /**
     * Specifies category point chart with markers at each data point
     */
    Point = 3,
    /**
     * Specifies category step line chart
     */
    StepLine = 4,
    /**
     * Specifies category step area chart
     */
    StepArea = 5,
    /**
     * Specifies category spline line series with markers at each data point
     */
    Spline = 6,
    /**
     * Specifies category spline area series
     */
    SplineArea = 7,
    /**
     * Specifies category waterfall chart
     */
    Waterfall = 8,
    /**
     * Specifies automatic selection of chart type based on suggestions from Data Adapter
     */
    Auto = 9
}
/**
 * @hidden
 */
export declare let CategoryChartType_$type: Type;
