import { Base, Type } from "igniteui-angular-core/ES2015/type";
import { AxisVisualDataList } from "./AxisVisualDataList";
import { SeriesVisualDataList } from "./SeriesVisualDataList";
import { ChartTitleVisualData } from "./ChartTitleVisualData";
import { RectData } from "igniteui-angular-core/ES2015/RectData";
import { GetPointsSettings } from "igniteui-angular-core/ES2015/GetPointsSettings";
/**
 * @hidden
 */
export declare class ChartVisualData extends Base {
    static $t: Type;
    constructor();
    private _axes;
    axes: AxisVisualDataList;
    private _series;
    series: SeriesVisualDataList;
    private _title;
    title: ChartTitleVisualData;
    private _subtitle;
    subtitle: ChartTitleVisualData;
    private _width;
    width: number;
    private _height;
    height: number;
    private _contentArea;
    contentArea: RectData;
    private _centralArea;
    centralArea: RectData;
    private _plotArea;
    plotArea: RectData;
    private _name;
    name: string;
    private _isViewportScaled;
    isViewportScaled: boolean;
    scaleByViewport(): void;
    getBounds(): RectData;
    serialize(): string;
    getSerializedSeriesPoints(a: string, b: string, c: GetPointsSettings): string;
    private _dipScalingRatio;
    dipScalingRatio: number;
}
