/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnnotationLayer } from "./AnnotationLayer";
import { Brush } from "igniteui-angular-core/ES2015/Brush";
import { DependencyProperty } from "igniteui-angular-core/ES2015/DependencyProperty";
import { Series } from "./Series";
import { Thickness } from "igniteui-angular-core/ES2015/Thickness";
import { Visibility_$type } from "igniteui-angular-core/ES2015/Visibility";
import { CrosshairLayerFrame } from "./CrosshairLayerFrame";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { Axis } from "./Axis";
import { Dictionary$2 } from "igniteui-angular-core/ES2015/Dictionary$2";
import { Pool$1 } from "igniteui-angular-core/ES2015/Pool$1";
import { AxisAnnotation } from "./AxisAnnotation";
import { Type, Number_$type, enumGetBox, fromEnum, Point_$type, markType, runOn } from "igniteui-angular-core/ES2015/type";
import { AxisAnnotationFrameManager } from "./AxisAnnotationFrameManager";
import { Tuple$2 } from "igniteui-angular-core/ES2015/Tuple$2";
import { Path } from "igniteui-angular-core/ES2015/Path";
import { PathGeometry } from "igniteui-angular-core/ES2015/PathGeometry";
import { PathFigure } from "igniteui-angular-core/ES2015/PathFigure";
import { LineSegment } from "igniteui-angular-core/ES2015/LineSegment";
import { PropertyMetadata } from "igniteui-angular-core/ES2015/PropertyMetadata";
import { isNaN_ } from "igniteui-angular-core/ES2015/number";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { TranslateTransform } from "igniteui-angular-core/ES2015/TranslateTransform";
import { LineGeometry } from "igniteui-angular-core/ES2015/LineGeometry";
import { BrushUtil } from "igniteui-angular-core/ES2015/BrushUtil";
/**
 * @hidden
 */
export class CrosshairLayer extends AnnotationLayer {
    constructor() {
        super();
        this.xAxisAnnotationFormatLabel = null;
        this.yAxisAnnotationFormatLabel = null;
        this.ne = null;
        this.nd = null;
        let a = new CrosshairLayerFrame();
        let b = new CrosshairLayerFrame();
        let c = new CrosshairLayerFrame();
        let d = this.fi / 1000;
        this.l2 = a;
        this.l1 = b;
        this.l3 = c;
        this.ab = CrosshairLayer.$;
    }
    bf() {
        return new CrosshairLayerView(this);
    }
    iu(a) {
        super.iu(a);
        this.m6 = a;
    }
    m8() {
        return this.xAxisAnnotationFormatLabel != null;
    }
    m9() {
        return this.yAxisAnnotationFormatLabel != null;
    }
    get pi() {
        return new Thickness(1, this.ng, this.ni, this.nh, this.nf);
    }
    get pj() {
        return new Thickness(1, this.nl, this.nn, this.nm, this.nk);
    }
    ml(a, b) {
        if (this.m7 == null || this.m7 == a) {
            if (!this.aq.c) {
                this.jd(b);
            }
        }
    }
    mn(a, b) {
        super.mn(a, b);
        let c = a;
        let d = this.nc;
        let e = this.nb;
        c.ad.clear();
        c.ae.clear();
        c.ac.clear();
        c.af.clear();
        AxisAnnotationFrameManager.b(c);
        if (this.l8(this.m7)) {
            this.oi(this.m7, c, d, e);
        }
        else {
            for (let f of fromEnum(this.bs.series)) {
                if (this.l8(f)) {
                    this.oi(f, c, d, e);
                }
            }
        }
    }
    l8(a) {
        if (!super.l8(a)) {
            return false;
        }
        let b = this.mg(a);
        if (!b.c) {
            return false;
        }
        return true;
    }
    io() {
        super.io();
        if (!this.aq.c && !this.ca()) {
            return;
        }
        if (this.ca()) {
            this.oj(this.l3, false);
        }
        else {
            this.oj(this.l1, false);
        }
    }
    oi(a, b, c, d) {
        let e = this.mg(a);
        if (!e.c) {
            return;
        }
        let f = e.d;
        f = a.ll(f, c, d);
        let g = this.k3;
        if (g == null) {
            g = this.k5;
        }
        if (g == null) {
            g = a.k3;
            if (g != null) {
                g = this.m6.b8(g);
            }
        }
        let h = g;
        let i = g;
        if (this.pa != null) {
            h = this.pa;
        }
        if (this.pb != null) {
            i = this.pb;
        }
        b.ac.add(h);
        b.af.add(i);
        b.ad.add(f.y);
        b.ae.add(f.x);
        if (this.na) {
            AxisAnnotationFrameManager.c(b, f, a, this.bs, this.getEffectiveViewport(), g, this.pc, this.pe, this.pd, this.pi, this.nj, this.pf, this.ph, this.pg, this.pj, this.no, this.pl == 0, this.pk == 0);
        }
    }
    oj(a, b) {
        let c = false;
        if (this.nd == null) {
            c = true;
            this.ne = new List$1(Axis.$, 0);
            this.nd = new Dictionary$2(Axis.$, Pool$1.$.specialize(AxisAnnotation.$), 0);
        }
        AxisAnnotationFrameManager.d(this, a, c, this.nd, this.ne, b, this.np, this.nq, this.xAxisAnnotationFormatLabel, this.yAxisAnnotationFormatLabel);
    }
    oh(a, b, c, d, e) {
        let f = a.item(b);
        b++;
        if (e) {
            f._stroke = d.af._inner[c];
            f._fill = d.af._inner[c];
        }
        else {
            f._stroke = d.ac._inner[c];
            f._fill = d.ac._inner[c];
        }
        f.ac = this.ey;
        f.ai = this.lb;
        f.ad = this.lc;
        return new Tuple$2(Path.$, Number_$type, f, b);
    }
    mq(a, b) {
        super.mq(a, b);
        let c = this.m6.b2;
        let d = a;
        let e = d.ad.count;
        let f = 0;
        let g = b.br.left;
        let h = b.br.right;
        let i = b.br.top;
        let j = b.br.bottom;
        let k = this.pl == 0;
        let l = this.pk == 0;
        for (let m = 0; m < e; m++) {
            let n = Math.floor(d.ad._inner[m]);
            let o = Math.floor(d.ae._inner[m]);
            let p = null;
            if (k) {
                if (isNaN_(n)) {
                    continue;
                }
                let q = this.oh(c, f, m, d, true);
                p = q.c;
                f = q.d;
                let r = new PathGeometry();
                let s = new PathFigure();
                s._startPoint = { $type: Point_$type, x: o, y: i };
                let t = new LineSegment(1);
                t.c = { $type: Point_$type, x: o, y: j };
                s._segments.add(t);
                r.c.add(s);
                p.ak = r;
            }
            if (l) {
                if (isNaN_(n)) {
                    continue;
                }
                let u = this.oh(c, f, m, d, false);
                p = u.c;
                f = u.d;
                let v = new PathGeometry();
                let w = new PathFigure();
                w._startPoint = { $type: Point_$type, x: g, y: n };
                let x = new LineSegment(1);
                x.c = { $type: Point_$type, x: h, y: n };
                w._segments.add(x);
                v.c.add(w);
                p.ak = v;
            }
        }
        c.count = f;
        if (this.ca()) {
            this.oj(this.l3, true);
        }
        else {
            this.oj(this.l1, false);
        }
    }
    c8() {
        return true;
    }
    iz(a, b, c, d) {
        super.iz(a, b, c, d);
        switch (b) {
            case CrosshairLayer.$$p[1]:
                this.jd(true);
                break;
            case CrosshairLayer.$$p[7]:
                this.jd(true);
                break;
            case CrosshairLayer.$$p[4]:
                this.jd(true);
                break;
            case CrosshairLayer.$$p[2]:
            case CrosshairLayer.$$p[8]:
            case CrosshairLayer.$$p[10]:
            case CrosshairLayer.$$p[12]:
            case CrosshairLayer.$$p[14]:
            case CrosshairLayer.$$p[13]:
            case CrosshairLayer.$$p[11]:
            case CrosshairLayer.$$p[15]:
            case CrosshairLayer.$$p[16]:
            case CrosshairLayer.$$p[17]:
            case CrosshairLayer.$$p[19]:
            case CrosshairLayer.$$p[21]:
            case CrosshairLayer.$$p[23]:
            case CrosshairLayer.$$p[22]:
            case CrosshairLayer.$$p[20]:
            case CrosshairLayer.$$p[24]:
            case CrosshairLayer.$$p[25]:
            case CrosshairLayer.$$p[0]:
            case CrosshairLayer.$$p[6]:
            case CrosshairLayer.$$p[5]:
                this.jd(true);
                break;
        }
    }
}
CrosshairLayer.$t = markType(CrosshairLayer, 'CrosshairLayer', AnnotationLayer.$);
Type.dep(DependencyProperty, PropertyMetadata, CrosshairLayer, 'raisePropertyChanged', ['HorizontalLineStroke:pa:ok', [Brush.$, null], 'HorizontalLineVisibility:pk:ol', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'IsAxisAnnotationEnabled:na:om', [0, false], 'SkipUnknownValues:nb:on', [0, true], 'TargetSeries:m7:oo', [Series.$, null], 'UseInterpolation:nc:op', [0, true], 'VerticalLineStroke:pb:oq', [Brush.$, null], 'VerticalLineVisibility:pl:or', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'XAxisAnnotationBackground:pc:os', [Brush.$, null], 'XAxisAnnotationInterpolatedValuePrecision:np:ot', [1, -1], 'XAxisAnnotationOutline:pd:ou', [Brush.$, null], 'XAxisAnnotationPaddingBottom:nf:ov', [1, NaN], 'XAxisAnnotationPaddingLeft:ng:ow', [1, NaN], 'XAxisAnnotationPaddingRight:nh:ox', [1, NaN], 'XAxisAnnotationPaddingTop:ni:oy', [1, NaN], 'XAxisAnnotationStrokeThickness:nj:oz', [1, NaN], 'XAxisAnnotationTextColor:pe:o0', [Brush.$, null], 'YAxisAnnotationBackground:pf:o1', [Brush.$, null], 'YAxisAnnotationInterpolatedValuePrecision:nq:o2', [1, -1], 'YAxisAnnotationOutline:pg:o3', [Brush.$, null], 'YAxisAnnotationPaddingBottom:nk:o4', [1, NaN], 'YAxisAnnotationPaddingLeft:nl:o5', [1, NaN], 'YAxisAnnotationPaddingRight:nm:o6', [1, NaN], 'YAxisAnnotationPaddingTop:nn:o7', [1, NaN], 'YAxisAnnotationStrokeThickness:no:o8', [1, NaN], 'YAxisAnnotationTextColor:ph:o9', [Brush.$, null]]);
/**
 * @hidden
 */
export class CrosshairLayerView extends AnnotationLayerView {
    constructor(a) {
        super(a);
        this.b1 = null;
        this.b2 = null;
        this.b3 = null;
        this.b1 = a;
        this.b3 = new List$1(Path.$, 0);
    }
    ap() {
        super.ap();
        this.b2 = ((() => {
            let $ret = new Pool$1(Path.$);
            $ret.create = runOn(this, this.b9);
            $ret.activate = runOn(this, this.b4);
            $ret.disactivate = runOn(this, this.b6);
            $ret.destroy = runOn(this, this.b5);
            return $ret;
        })());
    }
    b9() {
        let a = new Path();
        a.j = new TranslateTransform();
        this.b3.add(a);
        return a;
    }
    b4(a) {
        a._visibility = 0;
    }
    b6(a) {
        a._visibility = 1;
    }
    b5(a) {
        this.b3.remove(a);
    }
    b7(a, b, c, d) {
        if (a.ak == null || a.ak.c.x != d || a.ak.d.x != c) {
            let e = ((() => {
                let $ret = new LineGeometry();
                $ret.d = { $type: Point_$type, x: c, y: b };
                $ret.c = { $type: Point_$type, x: d, y: b };
                return $ret;
            })());
            a.ak = e;
        }
    }
    b8(a) {
        if (a == null) {
            return a;
        }
        return BrushUtil.h(a, 0.1);
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d && !b) {
            for (let c = 0; c < this.b3.count; c++) {
                let d = this.b3._inner[c];
                if (d._visibility == 0) {
                    a.s(d);
                }
            }
        }
    }
    ai(a) {
        super.ai(a);
        for (let b = 0; b < this.b3.count; b++) {
            this.e.a2.exportPathData(a, this.b3._inner[b], "crosshairLine", ["Main", "Crosshair"]);
        }
    }
}
CrosshairLayerView.$t = markType(CrosshairLayerView, 'CrosshairLayerView', AnnotationLayerView.$);
//# sourceMappingURL=CrosshairLayer_combined.js.map