import { Type } from "igniteui-angular-core/ES2015/type";
/**
 * An enum representing the available price series types to display in the main chart.
 */
export declare enum FinancialChartType {
    /**
     * Automatically determine the price series type to display in the main chart.
     */
    Auto = 0,
    /**
     * Display financial bar series in the main chart.
     */
    Bar = 1,
    /**
     * Display candlestick series in the main chart.
     */
    Candle = 2,
    /**
     * Display column series in the main chart.
     */
    Column = 3,
    /**
     * Display line series in the main chart.
     */
    Line = 4
}
/**
 * @hidden
 */
export declare let FinancialChartType_$type: Type;
