import { EventEmitter, OnInit } from '@angular/core';
import { PropertyUpdatedEventArgs } from "igniteui-angular-core/ES2015/igx-property-updated-event-args";
import { IgxSeriesComponent } from "./igx-series-component";
import { BrushScale } from "./BrushScale";
/**
 * Represents a base class for brush scales.
*/
export declare const IgxBrushScaleComponent_PROVIDERS: any[];
export declare class IgxBrushScaleComponent implements OnInit {
    protected createImplementation(): BrushScale;
    ngOnInit(): void;
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: BrushScale; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgxBrushScaleComponent;
    private onImplementationCreated;
    constructor();
    /**
     * Gets the brushes collection used by this scale.
    */
    brushes: string[];
    /**
     * Gets the status of the scale
    */
    readonly isReady: boolean;
    /**
     * Checks if this item is a BrushScale
    */
    readonly isBrushScale: boolean;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected readonly hasUserValues: Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    /**
     * Registers a series with the scale. Under normal circumstances you should not need to call this manually.
    
    * @param series  * The series to register with the scale.
    */
    registerSeries(series: IgxSeriesComponent): void;
    /**
     * Unregisters a series with the scale. Under normal circumstances you should not need to call this manually.
    
    * @param series  * The series to unregister from the scale.
    */
    unregisterSeries(series: IgxSeriesComponent): void;
    /**
     * Gets a brush from the brushes collection by index.
    
    */
    getBrush(index: number): string;
    private _propertyUpdated;
    /**
     * Event raised when a property (including "effective" and non-dependency property) value changes.
    */
    readonly propertyUpdated: EventEmitter<{
        sender: any;
        args: PropertyUpdatedEventArgs;
    }>;
    protected _zoneRunner: (act: () => void) => void;
    protected _runInZone(act: () => void): void;
}
