import { IgPoint } from "igniteui-angular-core/ES2015/IgPoint";
import { IgxSeriesComponent } from "./igx-series-component";
import { IgxSeriesViewerComponent } from "./igx-series-viewer-component";
import { ChartMouseEventArgs as ChartMouseEventArgs_internal } from "./ChartMouseEventArgs";
/**
 * Provides data for IgxDataChartComponent mouse button related events.
*/
export declare class ChartMouseEventArgs {
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: ChartMouseEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets a reference to the object that raised the event.
    */
    readonly originalSource: any;
    /**
     * Gets the ItemsSource item associated with the current event.
    */
    item: any;
    /**
     * Gets the series associated with the current event.
    */
    series: IgxSeriesComponent;
    /**
     * Gets the Chart associated with the current event.
    */
    chart: IgxSeriesViewerComponent;
    /**
     * Provides a human readable description of the mouse button event.
    
    */
    toString(): string;
    /**
     * Returns the x- and y- coordinates of the mouse pointer position, optionally evaluated
     * against the origin of a supplied UIElement.
    
    * @param relativeTo  * Any UIElement derived object that is contained by the the engine plug-in
     * and connected to the object tree. To specify the object relative to the overall the engine
     * coordinate system, use a relativeTo value of null.
    */
    getPosition(relativeTo: any): IgPoint;
}
