import { EventEmitter, OnInit } from '@angular/core';
import { PropertyUpdatedEventArgs } from "igniteui-angular-core/ES2015/igx-property-updated-event-args";
import { ColorScale } from "./ColorScale";
/**
 * Base class for classes which provide colors corresponding to numeric values within a known list of numeric values.
*/
export declare const IgxColorScaleComponent_PROVIDERS: any[];
export declare abstract class IgxColorScaleComponent implements OnInit {
    protected createImplementation(): ColorScale;
    ngOnInit(): void;
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: ColorScale; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgxColorScaleComponent;
    private onImplementationCreated;
    constructor();
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected readonly hasUserValues: Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    private _propertyUpdated;
    /**
     * Event raised when a property (including "effective" and non-dependency property) value changes.
    */
    readonly propertyUpdated: EventEmitter<{
        sender: any;
        args: PropertyUpdatedEventArgs;
    }>;
    protected _zoneRunner: (act: () => void) => void;
    protected _runInZone(act: () => void): void;
}
