import { Type } from '@angular/core';
import { IgxAnnotationLayerComponent } from "./igx-annotation-layer-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { ItemToolTipLayer } from "./ItemToolTipLayer";
/**
 * Represents an annotation layer that displays tooltips for all target series individually.
*/
export declare const IgxItemToolTipLayerComponent_PROVIDERS: ({
    provide: typeof IgxAnnotationLayerComponent;
    useExisting: Type<any>;
} | {
    provide: typeof IgxSeriesComponent;
    useExisting: Type<any>;
})[];
export declare class IgxItemToolTipLayerComponent extends IgxAnnotationLayerComponent {
    protected createImplementation(): ItemToolTipLayer;
    /**
                                 * @hidden
                                 */
    readonly i: ItemToolTipLayer;
    constructor();
    /**
     * Gets whether the default tooltip behaviors for the chart are disabled if this layer is present.
    */
    readonly isDefaultTooltipBehaviorDisabled: boolean;
    /**
     * Gets or sets whether to use value interpolation when drawing the tooltips.
    */
    useInterpolation: boolean;
    /**
     * Gets or sets whether to skip past unknown values when searching for series values.
    */
    skipUnknownValues: boolean;
    /**
     * Hides any tooltips presented by the layer, if any.
    
    */
    hideToolTips(): void;
}
