import { Type } from '@angular/core';
import { IgxStrategyBasedIndicatorComponent } from "./igx-strategy-based-indicator-component";
import { IgxFinancialSeriesComponent } from "./igx-financial-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { ItemwiseStrategyBasedIndicator } from "./ItemwiseStrategyBasedIndicator";
/**
 * Financial indicator base class for doing calculating an itemwize indicator.
 * An itemwise indicator's individual values don't depend on any other values in the
 * collection so can always be independently recalculated. Also, because of this, the
 * base class handles all the looping logic and inheritors only need to provide the
 * actual calculation.
*/
export declare const IgxItemwiseStrategyBasedIndicatorComponent_PROVIDERS: ({
    provide: typeof IgxFinancialSeriesComponent;
    useExisting: Type<any>;
} | {
    provide: typeof IgxSeriesComponent;
    useExisting: Type<any>;
})[];
export declare abstract class IgxItemwiseStrategyBasedIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    /**
                                 * @hidden
                                 */
    readonly i: ItemwiseStrategyBasedIndicator;
    constructor();
}
