import { Type } from '@angular/core';
import { IgPoint } from "igniteui-angular-core/ES2015/IgPoint";
import { IgxColorScaleComponent } from "./igx-color-scale-component";
import { IgxScatterTriangulationSeriesComponent } from "./igx-scatter-triangulation-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { ScatterAreaSeries } from "./ScatterAreaSeries";
/**
 * Series class which draws a colored 2D surface based on a triangulation of XY data with numeric values assigned to each point.
*/
export declare const IgxScatterAreaSeriesComponent_PROVIDERS: ({
    provide: typeof IgxScatterTriangulationSeriesComponent;
    useExisting: Type<any>;
} | {
    provide: typeof IgxSeriesComponent;
    useExisting: Type<any>;
})[];
export declare class IgxScatterAreaSeriesComponent extends IgxScatterTriangulationSeriesComponent {
    protected createImplementation(): ScatterAreaSeries;
    /**
                                 * @hidden
                                 */
    readonly i: ScatterAreaSeries;
    constructor();
    /**
     * Gets or sets ColorScale used to resolve the color values of points in the series.
    */
    colorScale: IgxColorScaleComponent;
    /**
     * Gets or sets the name of the property on each data item containing a numeric value which can be converted to a color by the ColorScale.
    */
    colorMemberPath: string;
    protected _styling(container: any, component: any, parent?: any): void;
    getItemValue(item: any, memberPathName: string): any;
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    */
    getItem(world: IgPoint): any;
    /**
     * Attaches an image to the view of this series
    
    */
    attachImage(image: any): void;
}
