import { Visibility_$type } from "igniteui-angular-core/ES2015/Visibility";
import { Style } from "igniteui-angular-core/ES2015/igx-style";
import { MarkerType_$type } from "./MarkerType";
import { brushToString, stringToBrush, ensureEnum } from "igniteui-angular-core/ES2015/componentUtil";
/**
 * Provides data for IgxDataChartComponent stacked series.
*/
export class StackedSeriesCreatedEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets or sets the series brush.
    */
    get brush() {
        return brushToString(this.i.brush);
    }
    set brush(v) {
        this.i.brush = stringToBrush(v);
    }
    /**
     * Gets or sets the series legend item template.
    */
    get legendItemTemplate() {
        return this.i.legendItemTemplate;
    }
    set legendItemTemplate(v) {
        this.i.legendItemTemplate = v;
    }
    /**
     * Gets or sets the series legend item badge templae.
    */
    get legendItemBadgeTemplate() {
        return this.i.legendItemBadgeTemplate;
    }
    set legendItemBadgeTemplate(v) {
        this.i.legendItemBadgeTemplate = v;
    }
    /**
     * Gets or sets the visibility of the series legend.
    */
    get legendItemVisibility() {
        return this.i.legendItemVisibility;
    }
    set legendItemVisibility(v) {
        this.i.legendItemVisibility = ensureEnum(Visibility_$type, v);
    }
    /**
     * Gets or sets the series outline brush.
    */
    get outline() {
        return brushToString(this.i.outline);
    }
    set outline(v) {
        this.i.outline = stringToBrush(v);
    }
    /**
     * Gets the index of the series.
    */
    get index() {
        return this.i.index;
    }
    /**
     * Gets or sets the series outline thickness.
    */
    get thickness() {
        return this.i.thickness;
    }
    set thickness(v) {
        this.i.thickness = +v;
    }
    /**
     * Gets or sets the series title.
    */
    get title() {
        return this.i.title;
    }
    set title(v) {
        this.i.title = v;
    }
    /**
     * Gets or sets the series marker brush.
    */
    get markerBrush() {
        return brushToString(this.i.markerBrush);
    }
    set markerBrush(v) {
        this.i.markerBrush = stringToBrush(v);
    }
    /**
     * Gets or sets the series marker outline.
    */
    get markerOutline() {
        return brushToString(this.i.markerOutline);
    }
    set markerOutline(v) {
        this.i.markerOutline = stringToBrush(v);
    }
    /**
     * Gets or sets the series marker style.
    */
    get markerStyle() {
        if (this.i.markerStyle == null) {
            return null;
        }
        if (!this.i.markerStyle.externalObject) {
            let e = new Style();
            e._implementation = this.i.markerStyle;
            this.i.markerStyle.externalObject = e;
        }
        return this.i.markerStyle.externalObject;
    }
    set markerStyle(v) {
        v == null ? this.i.markerStyle = null : this.i.markerStyle = v.i;
    }
    /**
     * Gets or sets the series marker template.
    */
    get markerTemplate() {
        return this.i.markerTemplate;
    }
    set markerTemplate(v) {
        this.i.markerTemplate = v;
    }
    /**
     * Gets or sets the series marker type.
    */
    get markerType() {
        return this.i.markerType;
    }
    set markerType(v) {
        this.i.markerType = ensureEnum(MarkerType_$type, v);
    }
}
//# sourceMappingURL=igx-stacked-series-created-event-args.js.map