import { Type } from '@angular/core';
import { IgxBrushScaleComponent } from "./igx-brush-scale-component";
import { ValueBrushScale } from "./ValueBrushScale";
/**
 * Represents a brush scale that uses value-based brush selection.
*/
export declare const IgxValueBrushScaleComponent_PROVIDERS: {
    provide: typeof IgxBrushScaleComponent;
    useExisting: Type<any>;
}[];
export declare class IgxValueBrushScaleComponent extends IgxBrushScaleComponent {
    protected createImplementation(): ValueBrushScale;
    /**
                                 * @hidden
                                 */
    readonly i: ValueBrushScale;
    constructor();
    /**
     * Gets or sets the minimum value for this scale.
    */
    minimumValue: number;
    /**
     * Gets or sets the maximum value for this scale.
    */
    maximumValue: number;
    /**
     * Gets or sets whether the scale is logarithmic.
    */
    isLogarithmic: boolean;
    /**
     * Gets or sets the logarithm base for this scale.
    */
    logarithmBase: number;
    /**
     * Checks if the value brush scale is ready for usage in the chart
    */
    readonly isReady: boolean;
}
