import { Type } from "igniteui-angular-core/ES5/type";
/**
 * Describes available positions on the crossing axis at which the category tooltip can be displayed.
 */
export declare enum CategoryTooltipLayerPosition {
    /**
     * A position is selected automatically
     */
    Auto = 0,
    /**
     * Displays at the outside start of the axis.
     */
    OutsideStart = 1,
    /**
     * Displays at the inside start of the axis.
     */
    InsideStart = 2,
    /**
     * Displays at the inside end of the axis.
     */
    InsideEnd = 3,
    /**
     * Displays at the outside end of the axis.
     */
    OutsideEnd = 4
}
/**
 * @hidden
 */
export declare let CategoryTooltipLayerPosition_$type: Type;
