import { Type } from "igniteui-angular-core/ES5/type";
/**
 * Describes available positions on the crossing axis at which the category tooltip can be displayed.
 */
export declare enum FinalValueSelectionMode {
    /**
     * A mode is selected automatically
     */
    Auto = 0,
    /**
     * Displays the last value visible.
     */
    FinalVisible = 1,
    /**
     * Displays an interploated last value for when the series leaves view.
     */
    FinalVisibleInterpolated = 2,
    /**
     * Displays the last value in the series, whether visible or not.
     */
    Final = 3
}
/**
 * @hidden
 */
export declare let FinalValueSelectionMode_$type: Type;
