import { Brush } from "igniteui-angular-core/ES5/Brush";
import { XYChart } from "./XYChart";
import { DomWrapper } from "igniteui-angular-core/ES5/dom";
import { EventArgs, IList, Type } from "igniteui-angular-core/ES5/type";
import { IZoomSlider } from "igniteui-angular-core/ES5/IZoomSlider";
import { List$1 } from "igniteui-angular-core/ES5/List$1";
import { DataSeriesType } from "igniteui-angular-core/ES5/DataSeriesType";
import { IDataSeriesAdapterRule } from "igniteui-angular-core/ES5/IDataSeriesAdapterRule";
import { XamDataChart } from "./XamDataChart";
import { FinancialChartVolumeType } from "./FinancialChartVolumeType";
import { FinancialChartXAxisMode } from "./FinancialChartXAxisMode";
import { FinancialChartYAxisMode } from "./FinancialChartYAxisMode";
import { FinancialChartType } from "./FinancialChartType";
import { HorizontalAlignment } from "igniteui-angular-core/ES5/HorizontalAlignment";
import { FinancialIndicatorTypeCollection } from "./FinancialIndicatorTypeCollection";
import { FinancialOverlayTypeCollection } from "./FinancialOverlayTypeCollection";
import { AxisLabelsLocation } from "./AxisLabelsLocation";
import { FinancialChartZoomSliderType } from "./FinancialChartZoomSliderType";
import { BrushCollection } from "igniteui-angular-core/ES5/BrushCollection";
import { IndicatorDisplayTypeCollection } from "./IndicatorDisplayTypeCollection";
import { FinancialChartRangeSelectorOptionCollection } from "./FinancialChartRangeSelectorOptionCollection";
import { CustomIndicatorNameCollection } from "./CustomIndicatorNameCollection";
import { IChartLegend } from "igniteui-angular-core/ES5/IChartLegend";
import { ObservableCollection$1 } from "igniteui-angular-core/ES5/ObservableCollection$1";
import { TemplatedHtmlControl } from "./TemplatedHtmlControl";
import { FinancialChartContext } from "./FinancialChartContext";
import { FinancialChartToolbarContext } from "./FinancialChartToolbarContext";
import { FinancialChartToolbarViewModel } from "./FinancialChartToolbarViewModel";
import { Series } from "./Series";
import { Axis } from "./Axis";
import { DataSeries } from "igniteui-angular-core/ES5/DataSeries";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { TitleSettings } from "./TitleSettings";
import { FinancialChartCustomIndicatorArgs } from "./FinancialChartCustomIndicatorArgs";
import { FinancialChartTypePicker } from "./FinancialChartTypePicker";
import { FinancialChartIndicatorMenu } from "./FinancialChartIndicatorMenu";
import { TrendLineType } from "igniteui-angular-core/ES5/TrendLineType";
import { FinancialChartToolbarVisualData } from "./FinancialChartToolbarVisualData";
import { FinancialChartRangeSelectorViewModel } from "./FinancialChartRangeSelectorViewModel";
import { FinancialChartRangeSelectorVisualData } from "./FinancialChartRangeSelectorVisualData";
/**
 * @hidden
 */
export declare class FinancialChart extends XYChart {
    static $t: Type;
    protected g5(a: string, b: any, c: any): void;
    private wc;
    private wb;
    private v8;
    private wk;
    private qf;
    provideGrid(a: DomWrapper): void;
    onDocumentClick(a: Event): void;
    private sx;
    private sv;
    private ss;
    private su;
    private sw;
    private st;
    getContext(): FinancialChartContext;
    provideContainer(a: any): void;
    private wv;
    private w9;
    private vs;
    private w7;
    setGridRows(): void;
    protected gj(): void;
    private wr;
    private ws;
    private w1;
    private vr;
    private wi;
    protected gg(a: XamDataChart): void;
    private xc;
    private xf;
    private xd;
    private xe;
    sf(): number;
    gr(source_: any, a: number, b: any): void;
    gs(source_: any, a: number, b: any): void;
    gq(source_: any): void;
    gu(source_: any, a: number, b: any, c: any): void;
    protected gm(a: Series, b: number): void;
    private pl;
    private pm;
    private tf;
    tm: any;
    private tg;
    tn: any;
    private tc;
    tj: any;
    private th;
    to: any;
    private ti;
    tp: any;
    private td;
    tk: any;
    private te;
    tl: any;
    private q3;
    q4: IZoomSlider;
    protected get_cs(): number;
    protected set_cs(a: number): void;
    protected get_bq(): boolean;
    protected set_bq(a: boolean): void;
    private r8;
    sj: number;
    constructor();
    protected h9(): Axis;
    protected ia(): Axis;
    onAttachedToUI(): void;
    onDetachedFromUI(): void;
    protected u(a: DataSeries): DataSeriesType;
    protected get_b5(): List$1<DataSeriesType>;
    protected readonly b5: List$1<DataSeriesType>;
    protected get_b4(): List$1<IDataSeriesAdapterRule>;
    protected readonly b4: List$1<IDataSeriesAdapterRule>;
    private o8;
    private qm;
    private o7;
    protected f3(): void;
    protected f1(a: Series, b: number): void;
    protected hj(a: DataSeries): void;
    protected hm(): void;
    private pq;
    private pp;
    private pz;
    private ps;
    private tx;
    private o9;
    private qn;
    private qt;
    private qu;
    private qs;
    private qv;
    private readonly ra;
    private p9;
    private readonly qa;
    private readonly rd;
    private p7;
    private readonly p8;
    private readonly rb;
    private qb;
    private readonly qc;
    private readonly rc;
    private qg;
    private readonly qh;
    protected aq(a: DataSeries, b: DataSeriesType): Series;
    protected hl(): void;
    protected m8(a: (arg1: Axis) => void, b: string): void;
    protected nc(a: (arg1: Axis) => void, b: boolean): void;
    protected na(a: (arg1: TitleSettings) => void): void;
    protected ne(a: (arg1: TitleSettings) => void): void;
    protected nd(a: (arg1: AxisLabelSettings) => void): void;
    protected m9(a: (arg1: AxisLabelSettings) => void): void;
    protected gf(a: XamDataChart): void;
    private static ta;
    private tq;
    private ur;
    private v2;
    private vo;
    private vp;
    private vu;
    private vx;
    private vv;
    private vw;
    private vy;
    private s4;
    protected f9(a: (arg1: Series, arg2: number) => void): void;
    private qz;
    private volumeChart;
    private wm;
    private re;
    private ri;
    private rf;
    private rh;
    private wl;
    private qw;
    private qy;
    private w3;
    dj(): any;
    tv(): string;
    private qx;
    private w2;
    private rn;
    private w0;
    protected gc(): void;
    protected get_bv(): boolean;
    protected readonly rr: boolean;
    private w8;
    private wn;
    protected gz(a: (arg1: XamDataChart) => void, b: boolean, c: string): void;
    private v0;
    private ww;
    private readonly rq;
    private v1;
    private rj;
    private wq;
    private v5;
    private wa;
    private v9;
    private v3;
    private v4;
    private we;
    private wh;
    private wf;
    private vq;
    private wu;
    private w6;
    private v6;
    private w4;
    private rm;
    private wd;
    private vz;
    private wy;
    private wx;
    private wp;
    private v7;
    private rs;
    private w5;
    private vt;
    private wz;
    protected hq(a: Series, b: Series, c: DataSeries): void;
    protected m3(a: Axis): void;
    protected m5(a: Axis): void;
    private wg;
    protected gk(a: Series, b: number): void;
    protected g3(a: string, b: any, c: any): void;
    private q9;
    rp: boolean;
    private s3;
    tb: number;
    private sa;
    sn: number;
    private sc;
    sp: number;
    private sb;
    so: number;
    private sd;
    sq: number;
    readonly sm: number;
    readonly sl: number;
    private pr;
    pt: FinancialChartVolumeType;
    private pu;
    pv: FinancialChartXAxisMode;
    private pw;
    px: FinancialChartYAxisMode;
    private q6;
    rk: boolean;
    private pn;
    po: FinancialChartType;
    protected get_nk(): HorizontalAlignment;
    protected set_nk(a: HorizontalAlignment): void;
    private q7;
    rl: boolean;
    private p1;
    p2: FinancialIndicatorTypeCollection;
    private p3;
    p4: FinancialOverlayTypeCollection;
    private ru;
    private indicatorCharts;
    private q8;
    ro: boolean;
    protected get_cu(): number;
    protected set_cu(a: number): void;
    protected get_ih(): AxisLabelsLocation;
    protected set_ih(a: AxisLabelsLocation): void;
    private q0;
    zoomSliderChart: XamDataChart;
    private ql;
    private zoomSliderAxis;
    private o6;
    private zoomSliderXAxis;
    private py;
    p0: FinancialChartZoomSliderType;
    private op;
    ox: BrushCollection;
    private oq;
    oy: BrushCollection;
    private or;
    oz: BrushCollection;
    private os;
    o0: BrushCollection;
    private ou;
    o2: BrushCollection;
    private ot;
    o1: BrushCollection;
    private oo;
    ow: BrushCollection;
    private on;
    ov: BrushCollection;
    private r9;
    sk: number;
    private r7;
    si: number;
    private r6;
    sh: number;
    private qd;
    qe: IndicatorDisplayTypeCollection;
    private sz;
    s6: number;
    private r5;
    sg: number;
    private s2;
    s9: number;
    private s0;
    s7: number;
    private sy;
    s5: number;
    private s1;
    s8: number;
    private pi;
    pk: FinancialChartRangeSelectorOptionCollection;
    pj: FinancialChartRangeSelectorOptionCollection;
    private pe;
    customIndicatorNames: CustomIndicatorNameCollection;
    applyCustomIndicators: (sender: any, e: FinancialChartCustomIndicatorArgs) => void;
    protected get_bw(): boolean;
    protected set_bw(a: boolean): void;
    private xa;
    xb: Brush;
    private se;
    sr: number;
    private q5;
    rg: boolean;
    private p5;
    p6: IChartLegend;
    private o5;
    private xAxis;
    private qk;
    private yAxis;
    private qj;
    private volumeAxis;
    private o4;
    private volumeXAxis;
    private qi;
    private indicatorAxis;
    private o3;
    private indicatorXAxis;
    private rt;
    private rw;
    private rv;
    private ry;
    private r2;
    r4: Date;
    private r1;
    r3: Date;
    private rz;
    readonly xAxisBreaks: ObservableCollection$1<any>;
}
/**
 * @hidden
 */
export declare class FinancialChartToolbar extends TemplatedHtmlControl {
    static $t: Type;
    bg(a: DomWrapper): void;
    bl(a: Event): void;
    private o;
    constructor(a: FinancialChart, b: any);
    private r;
    s: FinancialChartRangeSelector;
    private z;
    aa: FinancialChartTypePicker;
    private p;
    q: FinancialChartIndicatorMenu;
    private bm;
    private bh;
    private bi;
    private bj;
    w: FinancialChartToolbarViewModel;
    v(): FinancialChartToolbarContext;
    l(a: any): void;
    private bk;
    private aq;
    au: Date;
    private ap;
    at: Date;
    private ao;
    as: Date;
    private an;
    ar: Date;
    rangeChanged: (sender: any, e: EventArgs) => void;
    chartTypeChanged: (sender: any, e: EventArgs) => void;
    trendLineTypeChanged: (sender: any, e: EventArgs) => void;
    volumeTypeChanged: (sender: any, e: EventArgs) => void;
    indicatorTypesChanged: (sender: any, e: EventArgs) => void;
    overlayTypesChanged: (sender: any, e: EventArgs) => void;
    bn(): void;
    private x;
    y: FinancialChartType;
    private ah;
    ai: TrendLineType;
    private ab;
    ac: FinancialChartVolumeType;
    private ad;
    ae: FinancialIndicatorTypeCollection;
    private af;
    ag: FinancialOverlayTypeCollection;
    static am(a: IList, b: IList): boolean;
    aj(): FinancialChartToolbarVisualData;
    private t;
    u: FinancialChartRangeSelectorOptionCollection;
    private ak;
    al: boolean;
}
/**
 * @hidden
 */
export declare class FinancialChartRangeSelector extends TemplatedHtmlControl {
    static $t: Type;
    private static x;
    q: FinancialChartRangeSelectorViewModel;
    v: Date;
    u: Date;
    t: Date;
    s: Date;
    ab(): void;
    constructor(a: any);
    l(a: any): void;
    private z;
    rangeChanged: (sender: any, e: EventArgs) => void;
    r(): FinancialChartRangeSelectorVisualData;
    o: FinancialChartRangeSelectorOptionCollection;
    private aa;
    private p;
}
