import { Type } from "igniteui-angular-core/ES5/type";
/**
 * Describes available types of a callout line for the labels.
 */
export declare enum LeaderLineType {
    /**
     * A straight line is drawn between the slice and its label.
     */
    Straight = 0,
    /**
     * A curved line is drawn between the slice and its label. The line follows makes a natural turn from the slice to the label.
     */
    Arc = 1,
    /**
     * A curved line is drawn between the slice and its label. The line starts radially from the slice and then turns to the label.
     */
    Spline = 2
}
/**
 * @hidden
 */
export declare let LeaderLineType_$type: Type;
