import { Type } from "igniteui-angular-core/ES5/type";
/**
 * An enum representing the available tooltip types to display in the chart.
 */
export declare enum ToolTipType {
    /**
     * Display default tooltip for each series in the chart.
     */
    Default = 0,
    /**
     * Display individual tooltips for all series in the chart.
     */
    Item = 1,
    /**
     * Display combined tooltip for all series in the chart.
     */
    Category = 2,
    /**
     * Display no tooltips in the chart.
     */
    None = 3
}
/**
 * @hidden
 */
export declare let ToolTipType_$type: Type;
