import { Type, EventEmitter } from '@angular/core';
import { CustomContourValueResolverEventArgs } from "./igx-custom-contour-value-resolver-event-args";
import { IgxContourValueResolverComponent } from "./igx-contour-value-resolver-component";
import { CustomContourValueResolver } from "./CustomContourValueResolver";
/**
 * ContourValueResolver class which fires an event to resolve the contour values.
*/
export declare const IgxCustomContourValueResolverComponent_PROVIDERS: {
    provide: typeof IgxContourValueResolverComponent;
    useExisting: Type<any>;
}[];
export declare class IgxCustomContourValueResolverComponent extends IgxContourValueResolverComponent {
    protected createImplementation(): CustomContourValueResolver;
    /**
                                 * @hidden
                                 */
    readonly i: CustomContourValueResolver;
    constructor();
    private _getCustomContourValues;
    /**
     * Event raised when retrieving the contour values.
    */
    readonly getCustomContourValues: EventEmitter<{
        sender: any;
        args: CustomContourValueResolverEventArgs;
    }>;
}
