import { LegendBase } from './LegendBase';
export declare const LegendBaseStyles: string[];
/**
 * Represents the base class for a legend in IgxDataChartComponent.
*/
export declare abstract class IgxLegendBaseComponent {
    protected _zoneRunner: (act: () => void) => void;
    protected _implementation: any;
    readonly i: LegendBase;
    private onImplementationCreated;
    constructor();
    protected abstract createImplementation(): any;
    /**
 * Gets if the legend is item-wise.
*/
    readonly isItemwise: boolean;
    /**
     * Gets if the legend is a financial legend.
    */
    readonly isFinancial: boolean;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected readonly hasUserValues: Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
}
