import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxContourValueResolverComponent } from "./igx-contour-value-resolver-component";
import { LinearContourValueResolver } from "./LinearContourValueResolver";
/**
 * ContourValueResolver class which resolves contour lines to be distributed at linear intervals from the data minimum to the data maximum.
*/
export var IgxLinearContourValueResolverComponent_PROVIDERS = [{ provide: IgxContourValueResolverComponent, useExisting: forwardRef(function () { return IgxLinearContourValueResolverComponent; }) }];
var IgxLinearContourValueResolverComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxLinearContourValueResolverComponent, _super);
    function IgxLinearContourValueResolverComponent() {
        return _super.call(this) || this;
    }
    IgxLinearContourValueResolverComponent_1 = IgxLinearContourValueResolverComponent;
    IgxLinearContourValueResolverComponent.prototype.createImplementation = function () {
        return new LinearContourValueResolver();
    };
    Object.defineProperty(IgxLinearContourValueResolverComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxLinearContourValueResolverComponent.prototype, "valueCount", {
        /**
         * Gets or sets how many contour values to return.
        */
        get: function () {
            return this.i.valueCount;
        },
        set: function (v) {
            this.i.valueCount = +v;
        },
        enumerable: true,
        configurable: true
    });
    var IgxLinearContourValueResolverComponent_1;
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxLinearContourValueResolverComponent.prototype, "valueCount", null);
    IgxLinearContourValueResolverComponent = IgxLinearContourValueResolverComponent_1 = tslib_1.__decorate([
        Component({
            selector: 'igx-linear-contour-value-resolver',
            template: "",
            providers: [{ provide: IgxContourValueResolverComponent, useExisting: forwardRef(function () { return IgxLinearContourValueResolverComponent_1; }) }],
            changeDetection: ChangeDetectionStrategy.OnPush
        }),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxLinearContourValueResolverComponent);
    return IgxLinearContourValueResolverComponent;
}(IgxContourValueResolverComponent));
export { IgxLinearContourValueResolverComponent };
//# sourceMappingURL=igx-linear-contour-value-resolver-component.js.map