import { Type } from '@angular/core';
import { UnknownValuePlotting } from "igniteui-angular-core/ES5/UnknownValuePlotting";
import { IgxAnchoredRadialSeriesComponent } from "./igx-anchored-radial-series-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { RadialLineSeries } from "./RadialLineSeries";
/**
 * Represents a IgxDataChartComponent radial line series.
*/
export declare const IgxRadialLineSeriesComponent_PROVIDERS: ({
    provide: typeof IgxMarkerSeriesComponent;
    useExisting: Type<any>;
} | {
    provide: typeof IgxSeriesComponent;
    useExisting: Type<any>;
})[];
export declare class IgxRadialLineSeriesComponent extends IgxAnchoredRadialSeriesComponent {
    protected createImplementation(): RadialLineSeries;
    /**
                                 * @hidden
                                 */
    readonly i: RadialLineSeries;
    constructor();
    /**
     * Determines how unknown values will be plotted on the chart.
     * Null and Double.NaN are two examples of unknown values.
    */
    unknownValuePlotting: UnknownValuePlotting;
    /**
     * When overridden in a derived class, is invoked whenever application code or internal processes
     * call ApplyTemplate.
    
    */
    onApplyTemplate(): void;
}
