import { RenderRequestedEventArgs as RenderRequestedEventArgs_internal } from "./RenderRequestedEventArgs";
import { ensureBool } from "igniteui-angular-core/ES5/componentUtil";
/**
 * EventArgs class for RenderRequested events.
*
* Use the `RenderRequested` class for RenderRequested events.
*/
var RenderRequestedEventArgs = /** @class */ (function () {
    function RenderRequestedEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    RenderRequestedEventArgs.prototype.createImplementation = function () {
        return new RenderRequestedEventArgs_internal();
    };
    Object.defineProperty(RenderRequestedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    RenderRequestedEventArgs.prototype.onImplementationCreated = function () {
    };
    RenderRequestedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(RenderRequestedEventArgs.prototype, "animate", {
        /**
         * True if animation is requested.
        *
        * Use the `animate` property true if the animation is requested.
        *
        * ```ts
        * e.animation = true;
        * ```
        */
        get: function () {
            return this.i.animate;
        },
        set: function (v) {
            this.i.animate = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    return RenderRequestedEventArgs;
}());
export { RenderRequestedEventArgs };
//# sourceMappingURL=igx-render-requested-event-args.js.map