import * as tslib_1 from "tslib";
import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxScatterBaseComponent } from "./igx-scatter-base-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { ScatterSeries } from "./ScatterSeries";
/**
 * Represents a IgxDataChartComponent scatter series
*/
export var IgxScatterSeriesComponent_PROVIDERS = [{ provide: IgxScatterBaseComponent, useExisting: forwardRef(function () { return IgxScatterSeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxScatterSeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxScatterSeriesComponent; }) }];
var IgxScatterSeriesComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxScatterSeriesComponent, _super);
    function IgxScatterSeriesComponent() {
        return _super.call(this) || this;
    }
    IgxScatterSeriesComponent_1 = IgxScatterSeriesComponent;
    IgxScatterSeriesComponent.prototype.createImplementation = function () {
        return new ScatterSeries();
    };
    Object.defineProperty(IgxScatterSeriesComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxScatterSeriesComponent.prototype, "isMarkerlessDisplayPreferred", {
        /**
         * Overridden by derived series classes to indicate when markerless display is preferred or not.
        */
        get: function () {
            return this.i.cy;
        },
        enumerable: true,
        configurable: true
    });
    var IgxScatterSeriesComponent_1;
    IgxScatterSeriesComponent = IgxScatterSeriesComponent_1 = tslib_1.__decorate([
        Component({
            selector: 'igx-scatter-series',
            template: "",
            providers: [{ provide: IgxScatterBaseComponent, useExisting: forwardRef(function () { return IgxScatterSeriesComponent_1; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxScatterSeriesComponent_1; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxScatterSeriesComponent_1; }) }],
            changeDetection: ChangeDetectionStrategy.OnPush
        }),
        tslib_1.__metadata("design:paramtypes", [])
    ], IgxScatterSeriesComponent);
    return IgxScatterSeriesComponent;
}(IgxScatterBaseComponent));
export { IgxScatterSeriesComponent };
//# sourceMappingURL=igx-scatter-series-component.js.map