import { EventEmitter, OnInit } from '@angular/core';
import { PropertyUpdatedEventArgs } from "igniteui-angular-core/ES5/igx-property-updated-event-args";
import { SizeScale } from "./SizeScale";
/**
 * Represents a scale that is used determine an object's size.
*/
export declare const IgxSizeScaleComponent_PROVIDERS: any[];
export declare class IgxSizeScaleComponent implements OnInit {
    protected createImplementation(): SizeScale;
    ngOnInit(): void;
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: SizeScale; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgxSizeScaleComponent;
    private onImplementationCreated;
    constructor();
    /**
     * Gets or sets the minimum value for this scale.
    */
    minimumValue: number;
    /**
     * Gets or sets the maximum value for this scale.
    */
    maximumValue: number;
    /**
     * Gets or sets whether the scale is logarithmic.
    */
    isLogarithmic: boolean;
    /**
     * Gets or sets the logarithm base for this scale.
    */
    logarithmBase: number;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected readonly hasUserValues: Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    private _propertyUpdated;
    /**
     * Event raised when a property (including "effective" and non-dependency property) value changes.
    */
    readonly propertyUpdated: EventEmitter<{
        sender: any;
        args: PropertyUpdatedEventArgs;
    }>;
    protected _zoneRunner: (act: () => void) => void;
    protected _runInZone(act: () => void): void;
}
