import { Visibility_$type } from "igniteui-angular-core/ES5/Visibility";
import { Style } from "igniteui-angular-core/ES5/igx-style";
import { MarkerType_$type } from "./MarkerType";
import { brushToString, stringToBrush, ensureEnum } from "igniteui-angular-core/ES5/componentUtil";
/**
 * Provides data for IgxDataChartComponent stacked series.
*/
var StackedSeriesCreatedEventArgs = /** @class */ (function () {
    function StackedSeriesCreatedEventArgs() {
    }
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    StackedSeriesCreatedEventArgs.prototype.onImplementationCreated = function () {
    };
    StackedSeriesCreatedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "brush", {
        /**
         * Gets or sets the series brush.
        */
        get: function () {
            return brushToString(this.i.brush);
        },
        set: function (v) {
            this.i.brush = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "legendItemTemplate", {
        /**
         * Gets or sets the series legend item template.
        */
        get: function () {
            return this.i.legendItemTemplate;
        },
        set: function (v) {
            this.i.legendItemTemplate = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "legendItemBadgeTemplate", {
        /**
         * Gets or sets the series legend item badge templae.
        */
        get: function () {
            return this.i.legendItemBadgeTemplate;
        },
        set: function (v) {
            this.i.legendItemBadgeTemplate = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "legendItemVisibility", {
        /**
         * Gets or sets the visibility of the series legend.
        */
        get: function () {
            return this.i.legendItemVisibility;
        },
        set: function (v) {
            this.i.legendItemVisibility = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "outline", {
        /**
         * Gets or sets the series outline brush.
        */
        get: function () {
            return brushToString(this.i.outline);
        },
        set: function (v) {
            this.i.outline = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "index", {
        /**
         * Gets the index of the series.
        */
        get: function () {
            return this.i.index;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "thickness", {
        /**
         * Gets or sets the series outline thickness.
        */
        get: function () {
            return this.i.thickness;
        },
        set: function (v) {
            this.i.thickness = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "title", {
        /**
         * Gets or sets the series title.
        */
        get: function () {
            return this.i.title;
        },
        set: function (v) {
            this.i.title = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "markerBrush", {
        /**
         * Gets or sets the series marker brush.
        */
        get: function () {
            return brushToString(this.i.markerBrush);
        },
        set: function (v) {
            this.i.markerBrush = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "markerOutline", {
        /**
         * Gets or sets the series marker outline.
        */
        get: function () {
            return brushToString(this.i.markerOutline);
        },
        set: function (v) {
            this.i.markerOutline = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "markerStyle", {
        /**
         * Gets or sets the series marker style.
        */
        get: function () {
            if (this.i.markerStyle == null) {
                return null;
            }
            if (!this.i.markerStyle.externalObject) {
                var e = new Style();
                e._implementation = this.i.markerStyle;
                this.i.markerStyle.externalObject = e;
            }
            return this.i.markerStyle.externalObject;
        },
        set: function (v) {
            v == null ? this.i.markerStyle = null : this.i.markerStyle = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "markerTemplate", {
        /**
         * Gets or sets the series marker template.
        */
        get: function () {
            return this.i.markerTemplate;
        },
        set: function (v) {
            this.i.markerTemplate = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StackedSeriesCreatedEventArgs.prototype, "markerType", {
        /**
         * Gets or sets the series marker type.
        */
        get: function () {
            return this.i.markerType;
        },
        set: function (v) {
            this.i.markerType = ensureEnum(MarkerType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    return StackedSeriesCreatedEventArgs;
}());
export { StackedSeriesCreatedEventArgs };
//# sourceMappingURL=igx-stacked-series-created-event-args.js.map