import * as tslib_1 from "tslib";
import { forwardRef, Input } from '@angular/core';
import { NumericScaleMode, NumericScaleMode_$type } from "./NumericScaleMode";
import { IgxNumericAxisBaseComponent } from "./igx-numeric-axis-base-component";
import { IgxAxisComponent } from "./igx-axis-component";
import { ensureEnum } from "igniteui-angular-core/ES5/componentUtil";
/**
 * Defines a set of basic methods and properties used to create a StraightNumeric axis.
*/
export var IgxStraightNumericAxisBaseComponent_PROVIDERS = [{ provide: IgxNumericAxisBaseComponent, useExisting: forwardRef(function () { return IgxStraightNumericAxisBaseComponent; }) }, { provide: IgxAxisComponent, useExisting: forwardRef(function () { return IgxStraightNumericAxisBaseComponent; }) }];
var IgxStraightNumericAxisBaseComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxStraightNumericAxisBaseComponent, _super);
    function IgxStraightNumericAxisBaseComponent() {
        return _super.call(this) || this;
    }
    Object.defineProperty(IgxStraightNumericAxisBaseComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxStraightNumericAxisBaseComponent.prototype, "scaleMode", {
        /**
         * Gets or sets the axis scale mode.
        *
        * `scaleMode` can be used on numeric axes to allow scaling data values using built-in scalers. The available scalers are linear or logarithmic.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis
        *         scaleMode="logarithmic">
        *     </igx-numeric-y-axis>
        *     <igx-line-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value">
        *     </igx-line-series>
        * </igx-data-chart>
        * ```
        *
        * ```ts
        * this.yAxis.scaleMode = NumericScaleMode.Logarithmic;
        * ```
        */
        get: function () {
            return this.i.lc;
        },
        set: function (v) {
            this.i.lc = ensureEnum(NumericScaleMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    tslib_1.__decorate([
        Input(),
        tslib_1.__metadata("design:type", Number),
        tslib_1.__metadata("design:paramtypes", [Number])
    ], IgxStraightNumericAxisBaseComponent.prototype, "scaleMode", null);
    return IgxStraightNumericAxisBaseComponent;
}(IgxNumericAxisBaseComponent));
export { IgxStraightNumericAxisBaseComponent };
//# sourceMappingURL=igx-straight-numeric-axis-base-component.js.map