import { TreemapNodePointerEventArgs as TreemapNodePointerEventArgs_internal } from "./TreemapNodePointerEventArgs";
import { fromPoint, toPoint, ensureBool } from "igniteui-angular-core/ES5/componentUtil";
var TreemapNodePointerEventArgs = /** @class */ (function () {
    function TreemapNodePointerEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    TreemapNodePointerEventArgs.prototype.createImplementation = function () {
        return new TreemapNodePointerEventArgs_internal();
    };
    Object.defineProperty(TreemapNodePointerEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    TreemapNodePointerEventArgs.prototype.onImplementationCreated = function () {
    };
    TreemapNodePointerEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(TreemapNodePointerEventArgs.prototype, "value", {
        get: function () {
            return this.i.value;
        },
        set: function (v) {
            this.i.value = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodePointerEventArgs.prototype, "sum", {
        get: function () {
            return this.i.sum;
        },
        set: function (v) {
            this.i.sum = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodePointerEventArgs.prototype, "customValue", {
        get: function () {
            return this.i.customValue;
        },
        set: function (v) {
            this.i.customValue = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodePointerEventArgs.prototype, "item", {
        get: function () {
            return this.i.item;
        },
        set: function (v) {
            this.i.item = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodePointerEventArgs.prototype, "parentItem", {
        get: function () {
            return this.i.parentItem;
        },
        set: function (v) {
            this.i.parentItem = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodePointerEventArgs.prototype, "position", {
        get: function () {
            return fromPoint(this.i.position);
        },
        set: function (v) {
            this.i.position = toPoint(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodePointerEventArgs.prototype, "isRightButton", {
        get: function () {
            return this.i.isRightButton;
        },
        set: function (v) {
            this.i.isRightButton = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodePointerEventArgs.prototype, "isHandled", {
        get: function () {
            return this.i.isHandled;
        },
        set: function (v) {
            this.i.isHandled = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodePointerEventArgs.prototype, "isOverHeader", {
        get: function () {
            return this.i.isOverHeader;
        },
        set: function (v) {
            this.i.isOverHeader = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodePointerEventArgs.prototype, "label", {
        get: function () {
            return this.i.label;
        },
        set: function (v) {
            this.i.label = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodePointerEventArgs.prototype, "parentValue", {
        get: function () {
            return this.i.parentValue;
        },
        set: function (v) {
            this.i.parentValue = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodePointerEventArgs.prototype, "parentLabel", {
        get: function () {
            return this.i.parentLabel;
        },
        set: function (v) {
            this.i.parentLabel = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TreemapNodePointerEventArgs.prototype, "parentSum", {
        get: function () {
            return this.i.parentSum;
        },
        set: function (v) {
            this.i.parentSum = +v;
        },
        enumerable: true,
        configurable: true
    });
    return TreemapNodePointerEventArgs;
}());
export { TreemapNodePointerEventArgs };
//# sourceMappingURL=igx-treemap-node-pointer-event-args.js.map